% Program som finner likevektslinje, periode og usikkerhet i svingeutslag
% fra data samlet inn i Cavendish-eksperimentet.
% Data lastes inn med LesData()-kommandoen under (egen m-fil).

% Husk at matlab ikke bruker komma som desimaltegn men punktum.
% Skrevet av Frantz Stabo-Eeg sept. 2006 for labkurs TFY4145 Mekanisk fysikk. 
% Redigert av Eirik Glimsdal, oktober 2007, og omskrevet sept/okt. 2008.
% Korrigert av Iver Bakken Sperstad, okt. 2009.

%%%%%%%%%%%%%%%%%%%% Likevektspunkt %%%%%%%%%%%%%%%%%%%%%%%%%

% MERK: Dette er hovedfila som kjres for  finne likevektspunktet etc.
% Filene med data m lastes ogs i fila svingeUtslagAvik.m.
[S,T]=LesData(0); 

%Se p data:
%figure(2)
%plot(T,S,'r.-')

% Definere tilpasningsstrrelser (startverdier for tilpasning).
alpha0=0;                         % Dempingsfaktor
delta0=10;                         % Fase til svinging ved t=0;
S0=460;                          % Estimert likevektslinje
A0= 20;                           % Estimert svingeamplitude ved t=0
T0=650;                           % Estimert svingetid
x0=[S0,A0,alpha0,2*pi/T0,delta0]; % Start punkt for optimaliseringsparametre

% Optimalisering av funksjons parametre fminsearch er en hendig liten
% Matlab funksjon som fikser dette bra. (Enda bedre i Matlab 7 !)
[x1 fval] = fminsearch(@svingeUtslagAvik,x0); % optimaliserer parametrene

std=sqrt(fval/length(T));                % Beregner standaraviket mellom mlingen og estimat
likevektS0=x1(1)                         % Tar ut likevektspunktet fra optimaliserte verdier
svingetidT=abs(2*pi/x1(4))              % Tar ut svingetiden T fra fra optimaliserte verdier
Sny=svingeUtslag(x1,T);                  % Beregner ny S(t) med optimaliserte parametre fra mledataene
% Plotting av resultat
figure(1)
hold on                                 % Gjr s flere grafer kan plottes i samme figur
plot(T,S,'b.')                          % Plotter virkelig mlt S(t)
plot(T,Sny,'r-')                        % Plotter estimert S(t)
plot(T,x1(1)+x1(2)*exp(-x1(3)*T),'b-.') % Plotter positiv omhyldningskurve
plot(T,x1(1)-x1(2)*exp(-x1(3)*T),'b-.') % Plotter negativ omhyldningskurve
plot(T,x1(1),'b-.')                     % Plotter likevektslinje
xlabel('Tid (s)')                       % Setter navn p x-aksen
ylabel('Svingeutslag (mm)')             % Setter navn p y-aksen
title('Svingeutslag som funksjon av tid') % Setter navn p figuren
% Legend gir forklaring til plott
%legend('Mlt',['Estimert S(t)=S0+Ae^{-\alpha*t}sin(2\pi t/T+\phi)'  '\newline' 'S0 = ' num2str(x1(1)) '\newline' 'A = ' num2str(x1(2)) '\newline' '\alpha = ' num2str(x1(3)) '\newline' 'T = ' num2str(2*pi/x1(4)) '\newline' '\phi = ' num2str(x1(5)*180/pi) '^{\circ}'  '\newline' '\DeltaS=' num2str(std)])
legend('Mlt',['Estimert S(t)=S0+Ae^{-\alpha*t}sin(2\pi t/T+\phi)'  '\newline' 'S0 = ' num2str(x1(1)) '\newline' 'T = ' num2str(2*pi/x1(4)) '\newline' '\DeltaS=' num2str(std)])
hold off

